'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reduxAxiosMiddleware = require('redux-axios-middleware');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _api = require('./api');

var _user = require('./user');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _reduxAxiosMiddleware.multiClientMiddleware)({
  default: {
    client: _api.api
  },
  user: {
    client: _user.user
  }
}, {
  interceptors: {
    request: [function (store, config) {
      var token = (0, _get2.default)(store.getState(), ['user', 'token']);
      if (token) {
        config.headers['Authorization'] = token;
      }

      // console.log('before request', {
      //   store,
      //   config,
      // })
      return config;
    }],
    response: [function (store, response) {
      // console.log('Response', {
      //   store,
      //   response,
      // })
      // const freshToken = response.headers.authorization
      //   ? response.headers.authorization
      //   : false
      // if (freshToken) {
      //   store.dispatch(refreshToken(freshToken))
      // }
      return response;
    }]
  }
});