'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDomainPath = undefined;

var _handleActions;

var _reduxActions = require('redux-actions');

var _immutable = require('immutable');

var _reduxPersist = require('redux-persist');

var _actions = require('./actions');

var _I18n = require('./I18n');

var _I18n2 = _interopRequireDefault(_I18n);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getDomainPath = exports.getDomainPath = function getDomainPath(url) {
  return ['domains', url.replace(/\/translations\/[a-z]{2}/, '')];
};

var handleRehydrate = function handleRehydrate(state, _ref) {
  var payload = _ref.payload;

  return payload && payload.i18n && payload.i18n.set ? payload.i18n : state;
};

var handleFetch = function handleFetch(state, _ref2) {
  var url = _ref2.payload.request.url;

  var path = getDomainPath(url);
  if (state.hasIn(path)) {
    return state.setIn(path, state.getIn(path).set('isLoading', true));
  }
  return state.setIn(path, new _I18n.I18nBlock({ isLoading: true }));
};

var handleFetchSuccess = function handleFetchSuccess(state, _ref3) {
  var data = _ref3.payload.data.data,
      url = _ref3.meta.previousAction.payload.request.url;

  var path = getDomainPath(url);
  return state.setIn(path, state.getIn(path).set('isLoading', false).set('isLoaded', true).set('texts', (0, _immutable.Map)(data)));
};

var handleFetchFail = function handleFetchFail(state, _ref4) {
  var error = _ref4.error,
      url = _ref4.meta.previousAction.payload.request.url;

  var path = getDomainPath(url);
  return state.setIn(path, state.getIn(path).set('isLoading', false));
};

var handleChangeLanguage = function handleChangeLanguage(state, _ref5) {
  var payload = _ref5.payload;

  return state.set('language', payload);
};

exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, _reduxPersist.REHYDRATE, handleRehydrate), _defineProperty(_handleActions, _actions.onI18nFetch, handleFetch), _defineProperty(_handleActions, _actions.onI18nFetch.success, handleFetchSuccess), _defineProperty(_handleActions, _actions.onI18nFetch.fail, handleFetchFail), _defineProperty(_handleActions, _actions.onChangeLanguage, handleChangeLanguage), _handleActions), new _I18n2.default());