'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.texts = exports.t = exports.translations = exports.currentDomain = exports.commonTranslations = exports.domains = exports.language = undefined;

var _reselect = require('reselect');

var _reduce = require('lodash/reduce');

var _reduce2 = _interopRequireDefault(_reduce);

var _I18n = require('./I18n');

var _selectors = require('../router/selectors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var baseState = function baseState(state) {
  return state.i18n;
};

var language = exports.language = (0, _reselect.createSelector)(baseState, function (state) {
  return state.get('language');
});

var domains = exports.domains = (0, _reselect.createSelector)(baseState, function (state) {
  return state.get('domains');
});

var commonTranslations = exports.commonTranslations = (0, _reselect.createSelector)(domains, function (domains) {
  return domains.get('/common').get('texts');
});

var currentDomain = exports.currentDomain = (0, _reselect.createSelector)([domains, _selectors.pathname], function (domains, domain) {
  return domains.has(domain) && domains.get(domain).get('isLoaded') ? domains.get(domain) : new _I18n.I18nBlock();
});

var translations = exports.translations = (0, _reselect.createSelector)(currentDomain, function (domain) {
  return domain.get('texts');
});

var t = exports.t = (0, _reselect.createSelector)([translations, commonTranslations], function (trs, common) {
  return function (key) {
    return trs.has(key) ? trs.get(key) : common.has(key) ? common.get(key) : key;
  };
});

var texts = exports.texts = function texts(_texts) {
  return (0, _reselect.createSelector)(t, function (t) {
    return (0, _reduce2.default)(_texts, function (res, el, key) {
      res[key] = t(el);
      return res;
    }, {});
  });
};