'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _onFetchTranslations = require('../onFetchTranslations');

var _I18n = require('../../I18n');

var _I18n2 = _interopRequireDefault(_I18n);

var _actions = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getState = function getState() {
  var i18n = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var blockName = arguments[1];
  var block = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var state = new _I18n2.default(_extends({
    language: 'te'
  }, i18n));
  if (blockName) {
    return state.set('domains', state.get('domains').set(blockName, new _I18n.I18nBlock(block)));
  }
  return state;
};

var mockGetState = jest.fn();
mockGetState.mockReturnValue({
  i18n: getState()
});
var mockDispatch = jest.fn();

describe('I18N thunk', function () {
  it('onFetchTranslations', function () {
    (0, _onFetchTranslations.onFetchTranslations)('/login')(mockDispatch, mockGetState);
    expect(mockGetState.mock.calls.length).toBe(1);
    expect(mockDispatch).toBeCalledWith((0, _actions.onI18nFetch)('te', '/login'));
  });
});