'use strict';

var _immutable = require('immutable');

var _selectors = require('../selectors');

var selectors = _interopRequireWildcard(_selectors);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var State = {
  lists: {
    accounts: new _immutable.Record({
      isLoading: 'isLoading',
      isLoaded: 'isLoaded',
      list: ['i1', 'i2']
    })()
  }
};

describe('Accounts selectors', function () {
  it('isLoading selector', function () {
    expect(selectors.isLoading(State)).toBe('isLoading');
  });

  it('isLoaded selector test', function () {
    expect(selectors.isLoaded(State)).toBe('isLoaded');
  });

  it('list selector test', function () {
    expect(selectors.accounts(State)).toEqual(['i1', 'i2']);
  });
});