'use strict';

var _immutable = require('immutable');

var _reducer = require('../reducer');

var _reducer2 = _interopRequireDefault(_reducer);

var _List = require('../../../../records/List');

var _Icon = require('../Icon');

var _actions = require('../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Icons reducer', function () {
  it('should return the initial state', function () {
    expect((0, _reducer2.default)(undefined, {})).toEqual(new _List.ListCommon());
  });

  it('should handle Fetch', function () {
    var newState = (0, _reducer2.default)(new _List.ListCommon(), (0, _actions.onIconsFetch)());
    expect(newState.get('isLoading')).toBeTruthy();
    expect(newState.get('list')).toEqual(new _List.ListCommon().get('list'));
  });

  it('should handle Fetch Success', function () {
    var payload = {
      data: {
        data: {
          items: [{ id: 1, name: 'i1' }, { id: 2, name: 'i2' }]
        }
      }
    };
    var newState = (0, _reducer2.default)(new _List.ListCommon(), _actions.onIconsFetch.success(payload));

    expect(newState.get('isLoading')).toBeFalsy();
    expect(newState.get('isLoading')).toBeFalsy();
    expect(newState.get('list')).toEqual((0, _immutable.List)([new _Icon.Icon({ id: 1, name: 'i1' }), new _Icon.Icon({ id: 2, name: 'i2' })]));
  });

  it('should handle Fetch Fail', function () {
    var payload = {
      error: 'error'
    };
    var newState = (0, _reducer2.default)(new _List.ListCommon(), _actions.onIconsFetch.fail(payload));

    expect(newState.get('isLoading')).toBeFalsy();
    expect(newState.get('isLoading')).toBeFalsy();
    expect(newState.get('list')).toEqual(new _List.ListCommon().get('list'));
  });
});