'use strict';

var _immutable = require('immutable');

var _List = require('../../../../records/List');

var _Icon = require('../Icon');

var _selectors = require('../selectors');

var s = _interopRequireWildcard(_selectors);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var list = (0, _immutable.List)([new _Icon.Icon({ id: 1, name: 'icon1name', entity_type_id: 11 }), new _Icon.Icon({ id: 2, entity_type_id: 1 })]);

var state = {
  lists: {
    icons: new _List.ListCommon({
      isLoading: 'isLoading',
      isLoaded: 'isLoaded',
      list: list
    })
  }
};

describe('Icons selectors', function () {
  it('isLoading selector', function () {
    expect(s.iconsIsLoading(state)).toBe('isLoading');
  });

  it('isLoaded selector test', function () {
    expect(s.iconsIsLoaded(state)).toBe('isLoaded');
  });

  it('list selector test', function () {
    expect(s.icons(state)).toEqual(list);
  });

  it('getIconNameById selector test', function () {
    expect(s.getIconNameById(state)(1)).toBe('icon1name');
  });

  it('iconsRatios selector test', function () {
    expect(s.iconsRatios(state).size).toBe(1);
  });
});