'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.iconsRatios = exports.getIconNameById = exports.getIconById = exports.iconsIsLoaded = exports.iconsIsLoading = exports.icons = undefined;

var _reselect = require('reselect');

var _consts = require('./consts');

var baseState = function baseState(state) {
  return state.lists.icons;
};

var icons = exports.icons = (0, _reselect.createSelector)([baseState], function (state) {
  return state.get('list');
});
var iconsIsLoading = exports.iconsIsLoading = (0, _reselect.createSelector)([baseState], function (state) {
  return state.get('isLoading');
});
var iconsIsLoaded = exports.iconsIsLoaded = (0, _reselect.createSelector)([baseState], function (state) {
  return state.get('isLoaded');
});
var getIconById = exports.getIconById = (0, _reselect.createSelector)(icons, function (icons) {
  return function (id) {
    return icons.find(function (el) {
      return el.id === id;
    });
  };
});
var getIconNameById = exports.getIconNameById = (0, _reselect.createSelector)(getIconById, function (getIcon) {
  return function (id) {
    var icon = getIcon(id);
    return icon ? icon.name : undefined;
  };
});
var iconsRatios = exports.iconsRatios = (0, _reselect.createSelector)(icons, function (res) {
  return res.filter(function (el) {
    return el && el.get && el.get('entity_type_id') === _consts.RATIO_TYPE_ID;
  });
});