'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Receiving = undefined;

var _handleActions;

var _reduxActions = require('redux-actions');

var _immutable = require('immutable');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Receiving = exports.Receiving = (0, _immutable.Record)({
  isLoading: false,
  isLoaded: false,
  list: []
});

var handleFetch = function handleFetch(state) {
  return state.set('isLoading', true);
};

var handleFetchSuccess = function handleFetchSuccess(state, _ref) {
  var payload = _ref.payload;

  return state.set('isLoaded', true).set('isLoading', false).set('list', (0, _get2.default)(payload, ['data', 'data', 'items'], []));
};

var handleFetchFail = function handleFetchFail(state, _ref2) {
  var error = _ref2.error;

  return state.set('isLoaded', false).set('isLoading', false);
};

exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, _actions.onReceivingFetch, handleFetch), _defineProperty(_handleActions, _actions.onReceivingFetch.success, handleFetchSuccess), _defineProperty(_handleActions, _actions.onReceivingFetch.fail, handleFetchFail), _handleActions), new Receiving());