'use strict';

var _reducer = require('../reducer');

var _reducer2 = _interopRequireDefault(_reducer);

var _List = require('../../../../records/List');

var _actions = require('../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Spending reducer', function () {
  it('should return the initial state', function () {
    expect((0, _reducer2.default)(undefined, {})).toEqual(new _List.ListCommon());
  });

  it('should handle Fetch', function () {
    var newState = (0, _reducer2.default)(new _List.ListCommon(), (0, _actions.onSpendingFetch)());
    expect(newState.get('isLoading')).toBeTruthy();
    expect(newState.get('list')).toEqual(new _List.ListCommon().get('list'));
  });

  it('should handle Fetch Success', function () {
    var payload = {
      data: {
        data: {
          items: [{ id: 1, name: 'i1' }, { id: 2, name: 'i2' }]
        }
      }
    };
    var newState = (0, _reducer2.default)(new _List.ListCommon(), _actions.onSpendingFetch.success(payload));

    expect(newState.get('isLoading')).toBeFalsy();
    expect(newState.get('isLoading')).toBeFalsy();
    expect(newState.getIn(['list', 0, 'id'])).toEqual(1);
    expect(newState.getIn(['list', 1, 'id'])).toEqual(2);
  });

  it('should handle Fetch Fail', function () {
    var payload = {
      error: 'error'
    };
    var newState = (0, _reducer2.default)(new _List.ListCommon(), _actions.onSpendingFetch.fail(payload));

    expect(newState.get('isLoading')).toBeFalsy();
    expect(newState.get('isLoading')).toBeFalsy();
    expect(newState.get('list')).toEqual(new _List.ListCommon().get('list'));
  });
});