'use strict';

var _immutable = require('immutable');

var _selectors = require('../selectors');

var s = _interopRequireWildcard(_selectors);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var State = {
  lists: {
    spending: (0, _immutable.fromJS)({
      isLoading: 'isLoading',
      isLoaded: 'isLoaded',
      list: ['i1', 'i2']
    })
  }
};

describe('Accounts selectors', function () {
  it('isLoading selector', function () {
    expect(s.spendingIsLoading(State)).toBe('isLoading');
  });

  it('isLoaded selector test', function () {
    expect(s.spendingIsLoaded(State)).toBe('isLoaded');
  });

  it('list selector test', function () {
    expect(s.spending(State)).toEqual((0, _immutable.fromJS)(['i1', 'i2']));
  });
});