'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _handleActions;

var _reduxActions = require('redux-actions');

var _immutable = require('immutable');

var _actions = require('./actions');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NotificationsRecord = (0, _immutable.Record)({
  lastNotification: (0, _immutable.Map)({
    autoDismiss: 7
  }),
  removedNotification: null
}, 'Notifications');

var Notifications = function (_NotificationsRecord) {
  _inherits(Notifications, _NotificationsRecord);

  function Notifications() {
    _classCallCheck(this, Notifications);

    return _possibleConstructorReturn(this, (Notifications.__proto__ || Object.getPrototypeOf(Notifications)).apply(this, arguments));
  }

  return Notifications;
}(NotificationsRecord);

var handleAdd = function handleAdd(state, _ref) {
  var payload = _ref.payload;

  return state.set('lastNotification', state.lastNotification.merge(payload));
};

var handleRemove = function handleRemove(state, _ref2) {
  var payload = _ref2.payload;

  return state.set('removedNotification', payload);
};

exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, _actions.notifications.add, handleAdd), _defineProperty(_handleActions, _actions.notifications.remove, handleRemove), _handleActions), new Notifications());