'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.notify = undefined;

var _actions = require('../actions');

var _selectors = require('../../i18n/selectors');

var universal = function universal(message, title, level) {
  return function (dispatch, getState) {
    var state = getState();
    var trs = (0, _selectors.t)(state);
    return dispatch(_actions.notifications.add({
      title: trs(title),
      message: trs(message),
      level: level
    }));
  };
};

var notify = exports.notify = {
  success: function success(message) {
    var title = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Success!';
    return universal(message, title, 'success');
  },
  error: function error(message) {
    var title = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Error';
    return universal(message, title, 'error');
  },
  warning: function warning(message) {
    var title = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Warning!';
    return universal(message, title, 'warning');
  },
  info: function info(message) {
    var title = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Info';
    return universal(message, title, 'info');
  }
};