'use strict';

var _selectors = require('../selectors');

var s = _interopRequireWildcard(_selectors);

var _Router = require('../Router');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var getState = function getState() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new _Router.Location({ pathname: '/' });
  return {
    router: new _Router.Router({
      location: state
    })
  };
};
var state = void 0;

describe('Router selectors', function () {
  it('location', function () {
    var location = new _Router.Location({ pathname: 'test' });
    state = getState(location);
    expect(s.location(state)).toEqual(new _Router.Location(location));
  });

  it('pathname', function () {
    var location = new _Router.Location({ pathname: 'test16' });
    state = getState(location);
    expect(s.pathname(state)).toBe('test16');
  });

  it('pathnameArr', function () {
    var location = new _Router.Location({ pathname: '/first/second' });
    state = getState(location);
    expect(s.pathnameArr(state)).toEqual(['', 'first', 'second']);
  });

  it('action', function () {
    var location = new _Router.Location({ pathname: '/first/second' });
    state = getState(location);
    expect(s.action(state)).toBe('first');
  });

  it('token', function () {
    var location = new _Router.Location({ pathname: '/first/second' });
    state = getState(location);
    expect(s.token(state)).toBe('second');
  });
});