'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _UserReceivings = require('./receiving/UserReceivings');

var _UserSpendings = require('./spending/UserSpendings');

var _Ratios = require('./ratios/Ratios');

var _UserTransactions = require('./transactions/UserTransactions');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Данные о пользователе для логина (регистрации)
 * @typedef {Object} User
 * @property {!boolean} isLogin - если true - это значит логин а не регистрация (false - регистрация)
 * @property {!string} username - Логин пользовтаеля (email)
 * @property {!string} password - пароль пользователя
 */
var UserRecord = (0, _immutable.Record)({
  isAuth: false,
  isLoading: false,

  token: null,
  username: null,
  email: null,
  status: null,
  receiving: new _UserReceivings.UserReceivings(),
  spending: new _UserSpendings.UserSpendings(),
  ratios: new _Ratios.UserRatios(),
  transactions: new _UserTransactions.UserTransactions()
}, 'User');

var User = function (_UserRecord) {
  _inherits(User, _UserRecord);

  function User() {
    _classCallCheck(this, User);

    return _possibleConstructorReturn(this, (User.__proto__ || Object.getPrototypeOf(User)).apply(this, arguments));
  }

  _createClass(User, [{
    key: 'rehydrate',
    value: function rehydrate() {
      this.setField('receiving', _UserReceivings.UserReceivings, 'UserReceivings');
      this.setField('spending', _UserSpendings.UserSpendings, 'UserSpendings');
      this.setField('ratios', _Ratios.UserRatios, 'UserRatios');
      this.setField('transactions', _UserTransactions.UserTransactions, 'UserTransactions');
      return this;
    }
  }, {
    key: 'setField',
    value: function setField(field, RecordEntity, recordName) {
      if (this.get(field)._name !== recordName) {
        var newField = new RecordEntity(this.get(field));
        if (newField.rehydrate) {
          this._map = this.set(field, newField.rehydrate());
        } else {
          this._map = this.set(field, newField);
        }
      }
    }
  }, {
    key: 'initials',
    value: function initials() {
      if (this.username) {
        return this.username;
      }

      return this.email;
    }
  }]);

  return User;
}(UserRecord);

exports.default = User;