'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getState = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _immutable = require('immutable');

var _UserSpendings = require('../spending/UserSpendings');

var _User = require('../User');

var _User2 = _interopRequireDefault(_User);

var _UserReceivings = require('../receiving/UserReceivings');

var _UserTransactions = require('../transactions/UserTransactions');

var _Ratios = require('../ratios/Ratios');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getState = exports.getState = function getState() {
  var user = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    user: new _User2.default(_extends({
      isAuth: 'isAuth',
      isLoading: 'isLoading',
      username: 'username',
      token: 'secretToken',
      spending: new _UserSpendings.UserSpendings({ list: (0, _immutable.List)([(0, _immutable.Map)({ id: 1 })]) }),
      receiving: new _UserReceivings.UserReceivings({ list: (0, _immutable.List)([(0, _immutable.Map)({ id: 2 })]) }),
      transactions: new _UserTransactions.UserTransactions({
        list: (0, _immutable.List)([new _UserTransactions.Transaction({
          id: 1,
          sequence_number: 1,
          amount: 50,
          user_ratio_id: 401,
          user_ratio_currency_id: 31,
          entity_type_id: 1,
          entity_id: 7,
          entity_currency_id: 31
        }), new _UserTransactions.Transaction({
          id: 2,
          sequence_number: 2,
          amount: 150,
          user_ratio_id: 401,
          user_ratio_currency_id: 31,
          entity_type_id: 1,
          entity_id: 9,
          entity_currency_id: 31
        }), new _UserTransactions.Transaction({
          id: 3,
          sequence_number: 3,
          amount: 250,
          user_ratio_id: 401,
          user_ratio_currency_id: 31,
          entity_type_id: 1,
          entity_id: 7,
          entity_currency_id: 31
        })])
      }),
      ratios: new _Ratios.UserRatios({
        list: (0, _immutable.List)([new _Ratios.Ratio({
          color: '#47948a',
          currency_id: null,
          icon: { id: 41, name: 'iconName' },
          id: 1,
          is_balance: true,
          name: 'Cach',
          balance: 0
        })])
      })
    }, user))
  };
};