'use strict';

var _actions = require('../actions');

var ENTITY_NAME = 'USER';

describe('User actions', function () {
  it('registerUser', function () {
    var user = { username: 'test', password: 'secret' };
    var expectedAction = {
      type: 'REGISTER_' + ENTITY_NAME,
      payload: {
        client: 'user',
        request: {
          url: '/signup',
          method: 'post',
          data: user
        }
      }
    };
    expect((0, _actions.registerUser)(user)).toEqual(expectedAction);
  });

  it('registerUserSuccess', function () {
    var payload = { data: { username: 'test', password: 'secret' } };
    var expectedAction = {
      type: 'REGISTER_' + ENTITY_NAME + '_SUCCESS',
      payload: payload
    };
    expect((0, _actions.registerUserSuccess)(payload)).toEqual(expectedAction);
  });

  it('loginUser', function () {
    var user = { username: 'test', password: 'secret' };
    var expectedAction = {
      type: 'LOGIN_' + ENTITY_NAME,
      payload: {
        client: 'user',
        request: {
          url: '/login',
          method: 'post',
          data: user
        }
      }
    };
    expect((0, _actions.loginUser)(user)).toEqual(expectedAction);
  });
});