'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.refreshToken = exports.userConfirmEmailFail = exports.userConfirmEmailSuccess = exports.userConfirmEmail = exports.loginUserFail = exports.loginUserSuccess = exports.loginUser = exports.registerUserFail = exports.registerUserSuccess = exports.registerUser = undefined;

var _thunk = require('./thunk');

Object.keys(_thunk).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _thunk[key];
    }
  });
});

var _actions = require('./spending/actions');

Object.keys(_actions).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _actions[key];
    }
  });
});

var _reduxActions = require('redux-actions');

var _helpers = require('../../helpers');

var _createActions$type = _helpers.createActions.type('REGISTER_', 'USER', function (user) {
  return {
    client: 'user',
    request: {
      method: 'post',
      url: '/signup',
      data: user
    }
  };
}),
    registerUser = _createActions$type.registerUser,
    registerUserSuccess = _createActions$type.registerUserSuccess,
    registerUserFail = _createActions$type.registerUserFail;

exports.registerUser = registerUser;
exports.registerUserSuccess = registerUserSuccess;
exports.registerUserFail = registerUserFail;

var _createActions$type2 = _helpers.createActions.type('LOGIN_', 'USER', function (user) {
  return {
    client: 'user',
    request: {
      method: 'post',
      url: '/login',
      data: user
    }
  };
}),
    loginUser = _createActions$type2.loginUser,
    loginUserSuccess = _createActions$type2.loginUserSuccess,
    loginUserFail = _createActions$type2.loginUserFail;

exports.loginUser = loginUser;
exports.loginUserSuccess = loginUserSuccess;
exports.loginUserFail = loginUserFail;

var _createActions$type3 = _helpers.createActions.type('USER', '_CONFIRM_EMAIL', function (token) {
  return {
    client: 'user',
    request: {
      url: '/confirm-email',
      params: { token: token }
    }
  };
}),
    userConfirmEmail = _createActions$type3.userConfirmEmail,
    userConfirmEmailSuccess = _createActions$type3.userConfirmEmailSuccess,
    userConfirmEmailFail = _createActions$type3.userConfirmEmailFail;

exports.userConfirmEmail = userConfirmEmail;
exports.userConfirmEmailSuccess = userConfirmEmailSuccess;
exports.userConfirmEmailFail = userConfirmEmailFail;
var refreshToken = exports.refreshToken = (0, _reduxActions.createAction)('USER_REFRESH_TOKEN', function (token) {
  return token;
});