'use strict';

var _Ratios = require('../Ratios');

describe('Ratios Record', function () {
  it('create empty Ratio', function () {
    var ratio = new _Ratios.Ratio();
    expect(ratio.icon._name).toBe('Icon');
  });

  it('create empty2 Ratio', function () {
    var ratio = new _Ratios.Ratio(undefined);
    expect(ratio.icon._name).toBe('Icon');
  });

  it('create empty3 Ratio', function () {
    var ratio = new _Ratios.Ratio(null);
    expect(ratio.icon._name).toBe('Icon');
  });

  it('create Ratio with icon data', function () {
    var ratio = new _Ratios.Ratio({ icon: { id: 1, name: 'iconName' } });
    expect(ratio.icon._name).toBe('Icon');
    expect(ratio.icon.id).toBe(1);
    expect(ratio.icon.name).toBe('iconName');
  });

  it('create Ratio with data', function () {
    var ratio = new _Ratios.Ratio({ id: 12 });
    expect(ratio.icon._name).toBe('Icon');
  });
});