'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onDeleteRatio = exports.onPutRatio = exports.onPostRatio = exports.onFetchRatios = undefined;

var _thunk = require('./thunk');

Object.keys(_thunk).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _thunk[key];
    }
  });
});

var _actionCreators = require('../../../actionCreators');

var onFetchRatios = exports.onFetchRatios = (0, _actionCreators.createRequestActions)('RATIOS/FETCH', function () {
  return {
    request: {
      url: '/userRatio'
    }
  };
});

var onPostRatio = exports.onPostRatio = (0, _actionCreators.createRequestActions)('RATIOS/POST', function (data) {
  return {
    request: {
      url: '/userRatio',
      method: 'POST',
      data: data
    }
  };
});

var onPutRatio = exports.onPutRatio = (0, _actionCreators.createRequestActions)('RATIOS/PUT', function (data, index) {
  return {
    request: {
      url: '/userRatio/' + data.id,
      method: 'PUT',
      data: data
    },
    index: index
  };
});

var onDeleteRatio = exports.onDeleteRatio = (0, _actionCreators.createRequestActions)('RATIOS/DELETE', function (data, index) {
  return {
    request: {
      url: '/userRatio/' + data.id,
      method: 'DELETE',
      data: data
    },
    index: index
  };
});