'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _handleActions;

var _reduxActions = require('redux-actions');

var _immutable = require('immutable');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _Ratios = require('./Ratios');

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var handleFetchRatios = function handleFetchRatios(state) {
  return state.set('isLoading', true);
};

var handleFetchSuccess = function handleFetchSuccess(state, _ref) {
  var payload = _ref.payload;

  return state.set('isLoading', false).set('list', (0, _immutable.List)((0, _get2.default)(payload, ['data', 'data', 'items'], []).map(function (i) {
    return new _Ratios.Ratio(i);
  })));
};

var handleFetchFail = function handleFetchFail(state, _ref2) {
  var error = _ref2.error;

  return state.set('isLoading', false);
};

var handlePost = function handlePost(state, _ref3) {
  var data = _ref3.payload.request.data;

  return state.set('isLoading', true).set('list', state.get('list').push(new _Ratios.Ratio(data)));
};

var handlePut = function handlePut(state, _ref4) {
  var _ref4$payload = _ref4.payload,
      data = _ref4$payload.request.data,
      index = _ref4$payload.index;

  return state.set('isLoading', true).set('list', state.get('list').set(index, new _Ratios.Ratio(data)));
};

var handlePostSuccess = function handlePostSuccess(state, _ref5) {
  var payload = _ref5.payload;

  return state.set('isLoading', false).setIn(['list', state.list.size - 1, 'id'], (0, _get2.default)(payload, ['data', 'data', 'id']));
};

var handlePutSuccess = function handlePutSuccess(state) {
  return state.set('isLoading', false);
};

var handleDelete = function handleDelete(state, _ref6) {
  var _ref6$payload = _ref6.payload,
      data = _ref6$payload.request.data,
      index = _ref6$payload.index;

  return state.set('isLoading', true).set('list', state.get('list').delete(index));
};

var handleDeleteSuccess = function handleDeleteSuccess(state) {
  return state.set('isLoading', false);
};

exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, _actions.onFetchRatios, handleFetchRatios), _defineProperty(_handleActions, _actions.onFetchRatios.success, handleFetchSuccess), _defineProperty(_handleActions, _actions.onFetchRatios.fail, handleFetchFail), _defineProperty(_handleActions, _actions.onPostRatio, handlePost), _defineProperty(_handleActions, _actions.onPostRatio.success, handlePostSuccess), _defineProperty(_handleActions, _actions.onPostRatio.fail, handleFetchFail), _defineProperty(_handleActions, _actions.onPutRatio, handlePut), _defineProperty(_handleActions, _actions.onPutRatio.success, handlePutSuccess), _defineProperty(_handleActions, _actions.onPutRatio.fail, handleFetchFail), _defineProperty(_handleActions, _actions.onDeleteRatio, handleDelete), _defineProperty(_handleActions, _actions.onDeleteRatio.success, handleDeleteSuccess), _defineProperty(_handleActions, _actions.onDeleteRatio.fail, handleFetchFail), _handleActions), new _Ratios.UserRatios());