'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.balance = exports.ratioFormInitial = exports.ratioByIndex = exports.ratios = undefined;

var _reselect = require('reselect');

var baseState = function baseState(state) {
  return state.user.ratios;
};
var ratios = exports.ratios = (0, _reselect.createSelector)(baseState, function (ratios) {
  return ratios.get('list');
});
var ratioByIndex = exports.ratioByIndex = function ratioByIndex(index) {
  return (0, _reselect.createSelector)(ratios, function (ratios) {
    return ratios.has(index) ? ratios.get(index).toJS() : {};
  });
};
var ratioFormInitial = exports.ratioFormInitial = (0, _reselect.createSelector)(ratios, function (ratios) {
  return function (index) {
    var ratio = index >= 0 && ratios.has(index) ? ratios.get(index) : undefined;
    if (!ratio) {
      return undefined;
    }
    return {
      id: ratio.id,
      name: ratio.name,
      icon_id: ratio.icon.id,
      currency_id: ratio.currency_id,
      color: ratio.color,
      is_balance: ratio.is_balance
    };
  };
});
var balance = exports.balance = (0, _reselect.createSelector)(baseState, function (ratios) {
  return ratios.get('balance');
});