'use strict';

var _actions = require('../actions');

var ENTITY_NAME = 'USER_RECEIVING';

describe('UserReceiving actions', function () {
  it('userReceiving.get', function () {
    var expectedAction = {
      type: ENTITY_NAME + '/FETCH',
      payload: {
        request: {
          url: '/userReceivings'
        }
      }
    };
    expect((0, _actions.onFetchUserReceiving)()).toEqual(expectedAction);
  });

  it('userReceiving.getSuccess', function () {
    var expectedAction = {
      type: ENTITY_NAME + '/FETCH_SUCCESS',
      payload: 'data1'
    };
    expect(_actions.onFetchUserReceiving.success('data1')).toEqual(expectedAction);
  });

  it('userReceiving.getFail', function () {
    var expectedAction = {
      type: ENTITY_NAME + '/FETCH_FAIL',
      payload: 'data2'
    };
    expect(_actions.onFetchUserReceiving.fail('data2')).toEqual(expectedAction);
  });
});