'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _handleActions;

var _reduxActions = require('redux-actions');

var _reduxPersist = require('redux-persist');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _actions = require('./actions');

var _actions2 = require('./receiving/actions');

var _actions3 = require('./spending/actions');

var _actions4 = require('./ratios/actions');

var _reducer = require('./receiving/reducer');

var _reducer2 = _interopRequireDefault(_reducer);

var _reducer3 = require('./spending/reducer');

var _reducer4 = _interopRequireDefault(_reducer3);

var _reducer5 = require('./ratios/reducer');

var _reducer6 = _interopRequireDefault(_reducer5);

var _actions5 = require('./transactions/actions');

var _reducer7 = require('./transactions/reducer');

var _reducer8 = _interopRequireDefault(_reducer7);

var _User = require('./User');

var _User2 = _interopRequireDefault(_User);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var handleFlush = function handleFlush() {
  return new _User2.default();
};

var handleRehydrate = function handleRehydrate(state, _ref) {
  var payload = _ref.payload;

  var userData = (0, _get2.default)(payload, ['user']);
  return userData ? new _User2.default(userData).rehydrate() : state;
};

/* REGISTER */
var handleRegister = function handleRegister(state, _ref2) {
  var request = _ref2.payload.request;
  return state.set('isLoading', true).set('username', request.data.username);
};
var handleRegisterSuccess = function handleRegisterSuccess(state, _ref3) {
  var payload = _ref3.payload;
  return state.merge(payload.data).set('isLoading', false);
};
var handleRegisterFail = function handleRegisterFail(state, _ref4) {
  var error = _ref4.error;

  return state.set('isLoading', false).set('token', null);
};
/* END REGISTER */

/* LOGIN */
var handleLogin = function handleLogin(state, _ref5) {
  var request = _ref5.payload.request;
  return state.set('isLoading', true).set('username', request.data.username);
};
var handleAuthSuccess = function handleAuthSuccess(state, _ref6) {
  var payload = _ref6.payload;
  return state.set('isLoading', false).set('isAuth', true).merge(payload.data);
};
var handleAuthFail = function handleAuthFail(state, _ref7) {
  var error = _ref7.error;

  return state.set('isLoading', false);
};
/* END LOGIN */

var handleConfirmEmail = function handleConfirmEmail(state) {
  return state.set('isLoading', true);
};

var handleRefreshToken = function handleRefreshToken(state, _ref8) {
  var payload = _ref8.payload;
  return state.set('token', payload);
};

exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, _reduxPersist.FLUSH, handleFlush), _defineProperty(_handleActions, _reduxPersist.REHYDRATE, handleRehydrate), _defineProperty(_handleActions, _actions.registerUser, handleRegister), _defineProperty(_handleActions, _actions.registerUserSuccess, handleRegisterSuccess), _defineProperty(_handleActions, _actions.registerUserFail, handleRegisterFail), _defineProperty(_handleActions, _actions.loginUser, handleLogin), _defineProperty(_handleActions, (0, _reduxActions.combineActions)(_actions.loginUserSuccess, _actions.userConfirmEmailSuccess), handleAuthSuccess), _defineProperty(_handleActions, (0, _reduxActions.combineActions)(_actions.loginUserFail, _actions.userConfirmEmailFail), handleAuthFail), _defineProperty(_handleActions, _actions.refreshToken, handleRefreshToken), _defineProperty(_handleActions, _actions.userConfirmEmail, handleConfirmEmail), _defineProperty(_handleActions, (0, _reduxActions.combineActions)(_actions2.onFetchUserReceiving, _actions2.onFetchUserReceiving.success, _actions2.onFetchUserReceiving.fail), function (state, action) {
  return state.set('receiving', (0, _reducer2.default)(state.get('receiving'), action));
}), _defineProperty(_handleActions, (0, _reduxActions.combineActions)(_actions3.onFetchUserSpending, _actions3.onFetchUserSpending.success, _actions3.onFetchUserSpending.fail), function (state, action) {
  return state.set('spending', (0, _reducer4.default)(state.get('spending'), action));
}), _defineProperty(_handleActions, (0, _reduxActions.combineActions)(_actions4.onFetchRatios, _actions4.onFetchRatios.success, _actions4.onFetchRatios.fail, _actions4.onPostRatio, _actions4.onPostRatio.success, _actions4.onPostRatio.fail, _actions4.onPutRatio, _actions4.onPutRatio.success, _actions4.onPutRatio.fail, _actions4.onDeleteRatio, _actions4.onDeleteRatio.success, _actions4.onDeleteRatio.fail), function (state, action) {
  return state.set('ratios', (0, _reducer6.default)(state.get('ratios'), action));
}), _defineProperty(_handleActions, (0, _reduxActions.combineActions)(_actions5.onFetchTransactions, _actions5.onFetchTransactions.success, _actions5.onFetchTransactions.fail, _actions5.onPostTransaction, _actions5.onPostTransaction.success, _actions5.onPostTransaction.fail), function (state, action) {
  return state.set('transactions', (0, _reducer8.default)(state.get('transactions'), action));
}), _handleActions), new _User2.default());