'use strict';

var _actions = require('../actions');

var ENTITY_NAME = 'USER_SPENDING';

describe('UserSpending actions', function () {
  it('userSpending FETCH', function () {
    var expectedAction = {
      type: ENTITY_NAME + '/FETCH',
      payload: {
        request: {
          url: '/userSpendings'
        }
      }
    };
    expect((0, _actions.onFetchUserSpending)()).toEqual(expectedAction);
  });

  it('userSpending.getSuccess', function () {
    var expectedAction = {
      type: ENTITY_NAME + '/FETCH_SUCCESS',
      payload: 'data1'
    };
    expect(_actions.onFetchUserSpending.success('data1')).toEqual(expectedAction);
  });

  it('userSpending.getFail', function () {
    var expectedAction = {
      type: ENTITY_NAME + '/FETCH_FAIL',
      payload: 'data2'
    };
    expect(_actions.onFetchUserSpending.fail('data2')).toEqual(expectedAction);
  });
});