'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.actionHandler = undefined;

var _helpers = require('../../../helpers');

var _actions = require('../../notifications/actions');

var _actions2 = require('../../analytics/actions');

var _selectors = require('../../i18n/selectors');

var _selectors2 = require('../../router/selectors');

var _actions3 = require('../actions');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var actionHandler = exports.actionHandler = function actionHandler() {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(dispatch, getState) {
      var state, trs, actionName, token;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              state = getState();
              trs = (0, _selectors.t)(state);
              actionName = (0, _selectors2.action)(state);
              token = (0, _selectors2.token)(state);
              return _context2.abrupt('return', new Promise(function () {
                var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(resolve, reject) {
                  var executedAction, response;
                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.prev = 0;
                          executedAction = { 'confirm-email': _actions3.userConfirmEmail }[actionName];

                          if (!executedAction) {
                            _context.next = 14;
                            break;
                          }

                          _context.next = 5;
                          return dispatch(executedAction(token));

                        case 5:
                          response = _context.sent;

                          if (!response.error) {
                            _context.next = 10;
                            break;
                          }

                          dispatch(_actions.notifications.add({
                            title: 'Error',
                            message: trs((0, _helpers.getErrorMessage)(response)),
                            level: 'error'
                          }));
                          reject(response);
                          return _context.abrupt('return');

                        case 10:
                          dispatch(_actions.notifications.add({
                            title: 'Success',
                            message: trs((0, _helpers.getMessage)(response)),
                            level: 'success'
                          }));
                          resolve(response);
                          _context.next = 15;
                          break;

                        case 14:
                          reject(new Error('Action ' + actionName + ' not found'));

                        case 15:
                          _context.next = 22;
                          break;

                        case 17:
                          _context.prev = 17;
                          _context.t0 = _context['catch'](0);

                          dispatch(_actions2.analytics.error(_context.t0, actionName + ' Action'));
                          dispatch(_actions.notifications.add({
                            title: 'Error',
                            message: trs('error:unknown'),
                            level: 'error'
                          }));
                          reject(_context.t0);

                        case 22:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, undefined, [[0, 17]]);
                }));

                return function (_x3, _x4) {
                  return _ref2.apply(this, arguments);
                };
              }()));

            case 5:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};