'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Sector = undefined;

var _immutable = require('immutable');

/**
 * Данные, описывающие транзакцию Transaction
 * @typedef {Object} Sector
 * @property {!number} category_id - id категории для отображения (по этой информации можно определить цвет и иконку)
 * @property {!double} amount - сумма трат в этой категории
 * @property {!double} startAngle - угол с которого начинается категория на графике в радианах
 * @property {!double} endAngle - угол на котором заканчивается категория на графике в радианах
 * @property {!double} angle - центр угла на графике (используется для отображения иконки)
 */
var Sector = exports.Sector = (0, _immutable.Record)({
  category_id: null,
  amount: null,
  startAngle: null,
  endAngle: null,
  angle: null
});