'use strict';

var _UserTransactions = require('../../transactions/UserTransactions');

var _selectors = require('../../transactions/selectors');

var tr = _interopRequireWildcard(_selectors);

var _userStoreMock = require('../../__mocks__/userStoreMock');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var state = void 0;

describe('Transactions selectors', function () {
  it('transactions last', function () {
    state = (0, _userStoreMock.getState)();
    expect(tr.lastTransaction(state).id).toBe(3);
  });

  it('transactions grouped by spending category', function () {
    state = (0, _userStoreMock.getState)();
    expect(tr.spending(state).get(7)).toBe(300);
    expect(tr.spending(state).get(9)).toBe(150);
  });

  it('transactions common sum', function () {
    state = (0, _userStoreMock.getState)();
    expect(tr.spendingSum(state)).toBe(450);
  });

  it('transactions empty list', function () {
    state = (0, _userStoreMock.getState)({
      transactions: new _UserTransactions.UserTransactions()
    });
    expect(tr.spendingSum(state)).toBe(0);
  });

  it('transactions sectors', function () {
    state = (0, _userStoreMock.getState)();
    expect(tr.sectors(state).get(0).category_id).toBe(7);
    expect(tr.sectors(state).get(0).amount).toBe(300);
    expect(tr.sectors(state).get(0).startAngle).toBe(0);
    expect(tr.sectors(state).get(0).endAngle).toBe(4.1887902047863905);
    expect(tr.sectors(state).get(0).angle).toBe(2.0943951023931953);

    expect(tr.sectors(state).get(1).category_id).toBe(9);
    expect(tr.sectors(state).get(1).amount).toBe(150);
    expect(tr.sectors(state).get(1).startAngle).toBe(4.1887902047863905);
    expect(tr.sectors(state).get(1).endAngle).toBe(6.283185307179586);
    expect(tr.sectors(state).get(1).angle).toBe(5.235987755982988);
  });
});