'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onPostTransaction = exports.onFetchTransactions = undefined;

var _actionCreators = require('../../../actionCreators');

var BASE_NAME = 'USER_TRANSACTIONS';

var onFetchTransactions = exports.onFetchTransactions = (0, _actionCreators.createRequestActions)(BASE_NAME + '/FETCH', function () {
  return {
    request: {
      url: '/userTransactions'
    }
  };
});

/**
 * Post new transaction
 * @exports user/transactions:onPostTransaction
 * @param {Transaction} data - Данные для отправки на сервер
 * @example
 * import { onPostTransaction } from 'ratio-v-store/user/transactions';
 * const mapDispatchToProps = {
 *   onPostTransaction,
 * }
 * <button onClick={() => onPostTransaction(Transaction)} />
 */
var onPostTransaction = exports.onPostTransaction = (0, _actionCreators.createRequestActions)(BASE_NAME + '/POST', function (data) {
  return {
    request: {
      url: '/userTransactions',
      method: 'POST',
      data: data
    }
  };
});