'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _handleActions;

var _reduxActions = require('redux-actions');

var _immutable = require('immutable');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _UserTransactions = require('./UserTransactions');

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getUserTransactions = function getUserTransactions(state) {
  return state.set('isLoading', true);
};

var getSuccess = function getSuccess(state, _ref) {
  var payload = _ref.payload;

  return state.set('isLoading', false).set('list', (0, _immutable.List)((0, _get2.default)(payload, ['data', 'data', 'data'], []).map(function (i) {
    return new _UserTransactions.Transaction(i);
  })));
};

var getFail = function getFail(state) {
  return state.set('isLoading', false);
};

var postTransaction = function postTransaction(state, _ref2) {
  var data = _ref2.payload.request.data;

  return state.set('isLoading', true).set('list', state.list.push(new _UserTransactions.Transaction(data)));
};

var postSuccess = function postSuccess(state, _ref3) {
  var payload = _ref3.payload;

  return state.set('isLoading', false);
};

var postFail = function postFail(state) {
  return state.set('isLoading', false);
};

exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, _actions.onFetchTransactions, getUserTransactions), _defineProperty(_handleActions, _actions.onFetchTransactions.success, getSuccess), _defineProperty(_handleActions, _actions.onFetchTransactions.fail, getFail), _defineProperty(_handleActions, _actions.onPostTransaction, postTransaction), _defineProperty(_handleActions, _actions.onPostTransaction.success, postSuccess), _defineProperty(_handleActions, _actions.onPostTransaction.fail, postFail), _handleActions), new _UserTransactions.UserTransactions());