'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reducer = require('../reducer');

var _reducer2 = _interopRequireDefault(_reducer);

var _actions = require('../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getState = function getState(state) {
  return _extends({
    isLoading: false,
    isLoaded: false,
    versions: {}
  }, state);
};

describe('versions reducer', function () {
  it('initial state', function () {
    expect((0, _reducer2.default)(undefined, {})).toEqual(getState());
  });

  it('onVersionsFetch state', function () {
    expect((0, _reducer2.default)(getState({ isLoading: false }), (0, _actions.onVersionsFetch)())).toEqual(getState({ isLoading: true }));
  });

  it('onVersionsFetch.success state', function () {
    var payload = { data: { data: 'versions' } };
    expect((0, _reducer2.default)(getState({
      isLoading: true,
      isLoaded: false,
      versions: {}
    }), _actions.onVersionsFetch.success(payload))).toEqual(getState({
      isLoading: false,
      isLoaded: true,
      versions: 'versions'
    }));
  });

  it('onVersionsFetch.fail state', function () {
    expect((0, _reducer2.default)(getState({
      isLoading: true,
      isLoaded: true,
      versions: 'versions'
    }), _actions.onVersionsFetch.fail())).toEqual(getState({
      isLoading: false,
      isLoaded: true,
      versions: 'versions'
    }));
  });
});