'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initialState = undefined;

var _handleActions;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reduxActions = require('redux-actions');

var _reduxPersist = require('redux-persist');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _actions = require('./actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var initialState = exports.initialState = {
  isLoading: false,
  isLoaded: false,
  versions: {}
};

var handleFlush = function handleFlush() {
  return initialState;
};

var handleRehydrate = function handleRehydrate(state) {
  return _extends({}, state, { isLoading: false });
};

var handleVersionsFetch = function handleVersionsFetch(state) {
  return _extends({}, state, { isLoading: true });
};

var handleVersionsFetchSuccess = function handleVersionsFetchSuccess(state, _ref) {
  var payload = _ref.payload;

  return _extends({}, state, { versions: (0, _get2.default)(payload, ['data', 'data']), isLoading: false, isLoaded: true });
};

var handleVersionsFetchFail = function handleVersionsFetchFail(state) {
  return _extends({}, state, { isLoading: false });
};

exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, _reduxPersist.FLUSH, handleFlush), _defineProperty(_handleActions, _reduxPersist.REHYDRATE, handleRehydrate), _defineProperty(_handleActions, _actions.onVersionsFetch, handleVersionsFetch), _defineProperty(_handleActions, _actions.onVersionsFetch.success, handleVersionsFetchSuccess), _defineProperty(_handleActions, _actions.onVersionsFetch.fail, handleVersionsFetchFail), _handleActions), initialState);