'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isNeverReceived = exports.versionsIsLoaded = exports.versionsIsLoading = exports.versions = undefined;

var _reselect = require('reselect');

var baseState = function baseState(state) {
  return state.versions;
};

var versions = exports.versions = (0, _reselect.createSelector)(baseState, function (state) {
  return state.versions;
});

var versionsIsLoading = exports.versionsIsLoading = (0, _reselect.createSelector)(versions, function (state) {
  return state.isLoading;
});
var versionsIsLoaded = exports.versionsIsLoaded = (0, _reselect.createSelector)(versions, function (state) {
  return state.isLoaded;
});
var isNeverReceived = exports.isNeverReceived = (0, _reselect.createSelector)([versionsIsLoading, versionsIsLoaded], function (isLoading, isLoaded) {
  return !isLoading && !isLoaded;
});