'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onVersionsUpdate = undefined;

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _actions = require('../actions');

var _accounts = require('../../lists/accounts');

var _currencies = require('../../lists/currencies');

var _icons = require('../../lists/icons');

var _receiving = require('../../lists/receiving');

var _spending = require('../../lists/spending');

var _actions2 = require('../../user/ratios/actions');

var _actions3 = require('../../user/receiving/actions');

var _actions4 = require('../../user/spending/actions');

var _actions5 = require('../../user/transactions/actions');

var _actions6 = require('../../i18n/actions');

var _selectors = require('../../i18n/selectors');

var _selectors2 = require('../../router/selectors');

var _selectors3 = require('../selectors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var fields = {
  Account: _accounts.onAccountsFetch,
  Currency: _currencies.onCurrenciesFetch,
  Icon: _icons.onIconsFetch,
  Receiving: _receiving.onReceivingFetch,
  Spending: _spending.onSpendingFetch,
  UserCard: _actions2.onFetchRatios,
  Translation: _actions6.onI18nFetch,
  UserReceiving: _actions3.onFetchUserReceiving,
  UserSpending: _actions4.onFetchUserSpending
};

var onVersionsUpdate = exports.onVersionsUpdate = function onVersionsUpdate() {
  return function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(dispatch, getState) {
      var oldVersions, newVersions;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(0, _selectors3.versionsIsLoading)(getState())) {
                _context.next = 2;
                break;
              }

              return _context.abrupt('return');

            case 2:
              oldVersions = (0, _selectors3.versions)(getState());
              _context.next = 5;
              return dispatch((0, _actions.onVersionsFetch)());

            case 5:
              newVersions = (0, _selectors3.versions)(getState());

              (0, _map2.default)(newVersions, function (version, field) {
                if (version !== oldVersions[field]) {
                  if (fields[field]) {
                    if (field === 'translations') {
                      var lang = (0, _selectors.language)(getState());
                      dispatch(fields[field](lang, '/common'));
                      dispatch(fields[field](lang, (0, _selectors2.pathname)(getState())));
                    } else {
                      dispatch(fields[field]());
                    }
                  } else {
                    console.log('NOT FOUND ENTITY versions for entity ' + field + (' does not match! ' + version + ' and ' + oldVersions[field]));
                  }
                }
              });
              dispatch((0, _actions5.onFetchTransactions)());

            case 8:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};