'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createActions = exports.type = exports.save = exports.update = exports.insert = exports.fetch = exports.SAVE = exports.UPDATE = exports.INSERT = exports.FETCH = undefined;

var _reduxActions = require('redux-actions');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FETCH = exports.FETCH = 'FETCH_';
var INSERT = exports.INSERT = 'INSERT_';
var UPDATE = exports.UPDATE = 'UPDATE_';
var SAVE = exports.SAVE = 'SAVE_';

var SUCCESS = '_SUCCESS';
var FAIL = '_FAIL';

function createTypeAction(type, entity, handler) {
  return (0, _reduxActions.createActions)(_defineProperty({}, type + entity, handler), type + entity + SUCCESS, type + entity + FAIL);
}

var fetch = exports.fetch = function fetch(entity, handler) {
  return createTypeAction(FETCH, entity, handler);
};
var insert = exports.insert = function insert(entity, handler) {
  return createTypeAction(INSERT, entity, handler);
};
var update = exports.update = function update(entity, handler) {
  return createTypeAction(UPDATE, entity, handler);
};
var save = exports.save = function save(entity, handler) {
  return createTypeAction(SAVE, entity, handler);
};
var type = exports.type = createTypeAction;
var createActions = exports.createActions = {
  fetch: fetch,
  insert: insert,
  update: update,
  save: save,
  type: type
};