'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createStore = undefined;

var _redux = require('redux');

var _reduxPersist = require('redux-persist');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _dev = require('./dev');

var _rootReducer = require('./rootReducer');

var _rootReducer2 = _interopRequireDefault(_rootReducer);

var _clientsMiddleware = require('../clients/clientsMiddleware');

var _clientsMiddleware2 = _interopRequireDefault(_clientsMiddleware);

var _selectors = require('../entities/user/selectors');

var _actions = require('../entities/versions/actions');

var _actions2 = require('../entities/persist/actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

/**
 * initial actions
 */


var createStore = exports.createStore = function createStore(initialState, _ref) {
  var _ref$storage = _ref.storage,
      storage = _ref$storage === undefined ? null : _ref$storage,
      _ref$debug = _ref.debug,
      debug = _ref$debug === undefined ? false : _ref$debug,
      _ref$reducers = _ref.reducers,
      reducers = _ref$reducers === undefined ? {} : _ref$reducers,
      _ref$middlewares = _ref.middlewares,
      middlewares = _ref$middlewares === undefined ? [] : _ref$middlewares;

  middlewares = [_reduxThunk2.default, _clientsMiddleware2.default].concat(_toConsumableArray(middlewares));

  var store = (0, _redux.createStore)((0, _rootReducer2.default)(storage, reducers), initialState, (0, _dev.composeEnhancers)(debug)(_redux.applyMiddleware.apply(undefined, _toConsumableArray(middlewares))));

  var persistor = (0, _reduxPersist.persistStore)(store, null, function () {
    if ((0, _selectors.isAuth)(store.getState())) {
      Promise.all([store.dispatch((0, _actions.onVersionsUpdate)())]).then(function () {
        return console.log('[Начальные данные загружены!]');
      }).catch(function (err) {
        return console.log('Ошибка при получении начальных данных', err);
      });
    }
  });

  store.dispatch(_actions2.persist.set(persistor));

  if (module.hot) {
    module.hot.accept('./rootReducer', function () {
      var nextRootReducer = require('./rootReducer').default;
      store.replaceReducer(nextRootReducer(storage));
    });
  }

  return {
    persistor: persistor,
    store: store
  };
};