'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reduxForm = require('redux-form');

var _reduxPersist = require('redux-persist');

var _reduxPersistTransformImmutable = require('redux-persist-transform-immutable');

var _reduxPersistTransformImmutable2 = _interopRequireDefault(_reduxPersistTransformImmutable);

var _List = require('../records/List');

var _reducer = require('../entities/dialog/reducer');

var _reducer2 = _interopRequireDefault(_reducer);

var _reducer3 = require('../entities/i18n/reducer');

var _reducer4 = _interopRequireDefault(_reducer3);

var _I18n = require('../entities/i18n/I18n');

var _I18n2 = _interopRequireDefault(_I18n);

var _Icon = require('../entities/lists/icons/Icon');

var _Spending = require('../entities/lists/spending/Spending');

var _reducer5 = require('../entities/lists/reducer');

var _reducer6 = _interopRequireDefault(_reducer5);

var _reducer7 = require('../entities/notifications/reducer');

var _reducer8 = _interopRequireDefault(_reducer7);

var _reducer9 = require('../entities/persist/reducer');

var _reducer10 = _interopRequireDefault(_reducer9);

var _reducer11 = require('../entities/user/reducer');

var _reducer12 = _interopRequireDefault(_reducer11);

var _User = require('../entities/user/User');

var _User2 = _interopRequireDefault(_User);

var _UserSpendings = require('../entities/user/spending/UserSpendings');

var _UserReceivings = require('../entities/user/receiving/UserReceivings');

var _Ratios = require('../entities/user/ratios/Ratios');

var _UserTransactions = require('../entities/user/transactions/UserTransactions');

var _reducer13 = require('../entities/router/reducer');

var _reducer14 = _interopRequireDefault(_reducer13);

var _Router = require('../entities/router/Router');

var _reducer15 = require('../entities/versions/reducer');

var _reducer16 = _interopRequireDefault(_reducer15);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var persistConfig = {
  transforms: [(0, _reduxPersistTransformImmutable2.default)({
    records: [_I18n2.default, _I18n.I18nBlock, _Router.Router, _User2.default, _UserReceivings.UserReceivings, _UserSpendings.UserSpendings, _UserSpendings.UserSpending, _Ratios.Ratio, _Ratios.UserRatios, _List.ListCommon, _Icon.Icon, _Spending.Spending, _UserTransactions.UserTransactions, _UserTransactions.Transaction],
    whitelist: ['user', 'lists', 'i18n']
  })],
  key: 'RatioV',
  debug: true,
  whitelist: ['user', 'lists', 'versions', 'i18n', 'router']
};

exports.default = function (storage) {
  var reducers = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return (0, _reduxPersist.persistCombineReducers)(_extends({}, persistConfig, { storage: storage }), _extends({
    dialog: _reducer2.default,
    i18n: _reducer4.default,
    form: _reduxForm.reducer,
    lists: _reducer6.default,
    notifications: _reducer8.default,
    persist: _reducer10.default,
    router: _reducer14.default,
    user: _reducer12.default,
    versions: _reducer16.default
  }, reducers));
};