'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (actionCreator, type, payload) {
  var params = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

  it('' + type, function () {
    var action = {
      type: '' + type,
      payload: payload
    };
    expect(actionCreator.apply(undefined, _toConsumableArray(params))).toEqual(action);
  });

  it(type + '.toString', function () {
    expect(actionCreator.toString()).toEqual('' + type);
  });

  it(type + '.success', function () {
    var payload = 'payload';
    var action = {
      type: type + '_SUCCESS',
      payload: payload
    };
    expect(actionCreator.success(payload)).toEqual(action);
  });

  it(type + '.success.toString', function () {
    expect(actionCreator.success.toString()).toEqual(type + '_SUCCESS');
  });

  it(type + '.fail', function () {
    var payload = 'payload';
    var action = {
      type: type + '_FAIL',
      payload: payload
    };
    expect(actionCreator.fail(payload)).toEqual(action);
  });

  it(type + '.fail.toString', function () {
    expect(actionCreator.fail.toString()).toEqual(type + '_FAIL');
  });
};

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }