import { Map, Record } from 'immutable'

import getLanguage from '../../helpers/getLanguage'

const I18nBlockRecord = Record(
  {
    isLoading: false,
    isLoaded: false,
    texts: Map(),
  },
  'I18n/Block'
)

export class I18nBlock extends I18nBlockRecord {}

export const I18nRecord = Record(
  {
    language: getLanguage(),
    domains: Map({
      '/common': new I18nBlock({
        isLoaded: true,
        texts: Map({
          'Hello!': 'Приветствуем вас на сайте!',
        }),
      }),
    }),
  },
  'I18n'
)

export default class I18n extends I18nRecord {}
